import scala.collection.mutable.ListBuffer

def order(heap:ListBuffer[Int], first:Int, last:Int){
	var newFirst = first
	var largest = 2 * newFirst + 1
	var continue = true 
	while(continue  && largest <= last){
		if(largest < last && heap(largest) < heap(largest + 1)){
			largest = largest + 1
		}
		if(heap(largest) > heap(newFirst)){
			swap(heap, largest, newFirst)
			newFirst = largest
			largest = 2 * newFirst + 1
		}else{
			continue = false
		}
	}
}

def swap(heap:ListBuffer[Int], i:Int, j:Int){
	var tmp = heap(i)
	heap.update(i, heap(j))
	heap.update(j, tmp)
}

def sort(tab:ListBuffer[Int]){
	//Convert tab to heap
	var length = tab.length - 1
	var middle = length / 2
	//println(middle)
	var i = middle.toInt
	while(i >= 0){
		order(tab, i, length)
		i = i - 1
	}
	//Convert heap to tab
	var j = length
	while(j >= 1){
		if(tab(0) > tab(j)){
			swap(tab, 0, j)
			order(tab, 0, j-1)
		}
		j = j - 1
	}
	//checking
	for (nb <- tab){ println(nb)}
}

var numbers = new ListBuffer[Int]() 
numbers += (42,9,1,4,3,5,6,0,2,10,50) 
//for (nb <- numbers){ println(nb)}
sort(numbers)